// ==============================================================
// RTL generated by Vivado(TM) HLS - High-Level Synthesis from C, C++ and SystemC
// Version: 2018.3
// Copyright (C) 1986-2018 Xilinx, Inc. All Rights Reserved.
// 
// ===========================================================

`timescale 1 ns / 1 ps 

(* CORE_GENERATION_INFO="RGB2yfb,hls_ip_2018_3,{HLS_INPUT_TYPE=cxx,HLS_INPUT_FLOAT=0,HLS_INPUT_FIXED=0,HLS_INPUT_PART=xc7z010clg400-1,HLS_INPUT_CLOCK=7.500000,HLS_INPUT_ARCH=others,HLS_SYN_CLOCK=6.562000,HLS_SYN_LAT=-1,HLS_SYN_TPT=none,HLS_SYN_MEM=4,HLS_SYN_DSP=16,HLS_SYN_FF=2677,HLS_SYN_LUT=2699,HLS_VERSION=2018_3}" *)

module RGB2yfb (
        ap_clk,
        ap_rst_n,
        m_axi_gmem_AWVALID,
        m_axi_gmem_AWREADY,
        m_axi_gmem_AWADDR,
        m_axi_gmem_AWID,
        m_axi_gmem_AWLEN,
        m_axi_gmem_AWSIZE,
        m_axi_gmem_AWBURST,
        m_axi_gmem_AWLOCK,
        m_axi_gmem_AWCACHE,
        m_axi_gmem_AWPROT,
        m_axi_gmem_AWQOS,
        m_axi_gmem_AWREGION,
        m_axi_gmem_AWUSER,
        m_axi_gmem_WVALID,
        m_axi_gmem_WREADY,
        m_axi_gmem_WDATA,
        m_axi_gmem_WSTRB,
        m_axi_gmem_WLAST,
        m_axi_gmem_WID,
        m_axi_gmem_WUSER,
        m_axi_gmem_ARVALID,
        m_axi_gmem_ARREADY,
        m_axi_gmem_ARADDR,
        m_axi_gmem_ARID,
        m_axi_gmem_ARLEN,
        m_axi_gmem_ARSIZE,
        m_axi_gmem_ARBURST,
        m_axi_gmem_ARLOCK,
        m_axi_gmem_ARCACHE,
        m_axi_gmem_ARPROT,
        m_axi_gmem_ARQOS,
        m_axi_gmem_ARREGION,
        m_axi_gmem_ARUSER,
        m_axi_gmem_RVALID,
        m_axi_gmem_RREADY,
        m_axi_gmem_RDATA,
        m_axi_gmem_RLAST,
        m_axi_gmem_RID,
        m_axi_gmem_RUSER,
        m_axi_gmem_RRESP,
        m_axi_gmem_BVALID,
        m_axi_gmem_BREADY,
        m_axi_gmem_BRESP,
        m_axi_gmem_BID,
        m_axi_gmem_BUSER,
        video_in_TDATA,
        video_in_TVALID,
        video_in_TREADY,
        video_in_TKEEP,
        video_in_TSTRB,
        video_in_TUSER,
        video_in_TLAST,
        video_in_TID,
        video_in_TDEST,
        s_axi_AXILiteS_AWVALID,
        s_axi_AXILiteS_AWREADY,
        s_axi_AXILiteS_AWADDR,
        s_axi_AXILiteS_WVALID,
        s_axi_AXILiteS_WREADY,
        s_axi_AXILiteS_WDATA,
        s_axi_AXILiteS_WSTRB,
        s_axi_AXILiteS_ARVALID,
        s_axi_AXILiteS_ARREADY,
        s_axi_AXILiteS_ARADDR,
        s_axi_AXILiteS_RVALID,
        s_axi_AXILiteS_RREADY,
        s_axi_AXILiteS_RDATA,
        s_axi_AXILiteS_RRESP,
        s_axi_AXILiteS_BVALID,
        s_axi_AXILiteS_BREADY,
        s_axi_AXILiteS_BRESP,
        interrupt
);

parameter    ap_ST_fsm_state1 = 12'd1;
parameter    ap_ST_fsm_state2 = 12'd2;
parameter    ap_ST_fsm_state3 = 12'd4;
parameter    ap_ST_fsm_pp0_stage0 = 12'd8;
parameter    ap_ST_fsm_pp0_stage1 = 12'd16;
parameter    ap_ST_fsm_pp0_stage2 = 12'd32;
parameter    ap_ST_fsm_pp0_stage3 = 12'd64;
parameter    ap_ST_fsm_pp0_stage4 = 12'd128;
parameter    ap_ST_fsm_pp0_stage5 = 12'd256;
parameter    ap_ST_fsm_pp0_stage6 = 12'd512;
parameter    ap_ST_fsm_pp0_stage7 = 12'd1024;
parameter    ap_ST_fsm_state28 = 12'd2048;
parameter    C_S_AXI_AXILITES_DATA_WIDTH = 32;
parameter    C_S_AXI_AXILITES_ADDR_WIDTH = 6;
parameter    C_S_AXI_DATA_WIDTH = 32;
parameter    C_M_AXI_GMEM_ID_WIDTH = 1;
parameter    C_M_AXI_GMEM_ADDR_WIDTH = 32;
parameter    C_M_AXI_GMEM_DATA_WIDTH = 64;
parameter    C_M_AXI_GMEM_AWUSER_WIDTH = 1;
parameter    C_M_AXI_GMEM_ARUSER_WIDTH = 1;
parameter    C_M_AXI_GMEM_WUSER_WIDTH = 1;
parameter    C_M_AXI_GMEM_RUSER_WIDTH = 1;
parameter    C_M_AXI_GMEM_BUSER_WIDTH = 1;
parameter    C_M_AXI_GMEM_USER_VALUE = 0;
parameter    C_M_AXI_GMEM_PROT_VALUE = 0;
parameter    C_M_AXI_GMEM_CACHE_VALUE = 3;
parameter    C_M_AXI_DATA_WIDTH = 32;

parameter C_S_AXI_AXILITES_WSTRB_WIDTH = (32 / 8);
parameter C_S_AXI_WSTRB_WIDTH = (32 / 8);
parameter C_M_AXI_GMEM_WSTRB_WIDTH = (64 / 8);
parameter C_M_AXI_WSTRB_WIDTH = (32 / 8);

input   ap_clk;
input   ap_rst_n;
output   m_axi_gmem_AWVALID;
input   m_axi_gmem_AWREADY;
output  [C_M_AXI_GMEM_ADDR_WIDTH - 1:0] m_axi_gmem_AWADDR;
output  [C_M_AXI_GMEM_ID_WIDTH - 1:0] m_axi_gmem_AWID;
output  [7:0] m_axi_gmem_AWLEN;
output  [2:0] m_axi_gmem_AWSIZE;
output  [1:0] m_axi_gmem_AWBURST;
output  [1:0] m_axi_gmem_AWLOCK;
output  [3:0] m_axi_gmem_AWCACHE;
output  [2:0] m_axi_gmem_AWPROT;
output  [3:0] m_axi_gmem_AWQOS;
output  [3:0] m_axi_gmem_AWREGION;
output  [C_M_AXI_GMEM_AWUSER_WIDTH - 1:0] m_axi_gmem_AWUSER;
output   m_axi_gmem_WVALID;
input   m_axi_gmem_WREADY;
output  [C_M_AXI_GMEM_DATA_WIDTH - 1:0] m_axi_gmem_WDATA;
output  [C_M_AXI_GMEM_WSTRB_WIDTH - 1:0] m_axi_gmem_WSTRB;
output   m_axi_gmem_WLAST;
output  [C_M_AXI_GMEM_ID_WIDTH - 1:0] m_axi_gmem_WID;
output  [C_M_AXI_GMEM_WUSER_WIDTH - 1:0] m_axi_gmem_WUSER;
output   m_axi_gmem_ARVALID;
input   m_axi_gmem_ARREADY;
output  [C_M_AXI_GMEM_ADDR_WIDTH - 1:0] m_axi_gmem_ARADDR;
output  [C_M_AXI_GMEM_ID_WIDTH - 1:0] m_axi_gmem_ARID;
output  [7:0] m_axi_gmem_ARLEN;
output  [2:0] m_axi_gmem_ARSIZE;
output  [1:0] m_axi_gmem_ARBURST;
output  [1:0] m_axi_gmem_ARLOCK;
output  [3:0] m_axi_gmem_ARCACHE;
output  [2:0] m_axi_gmem_ARPROT;
output  [3:0] m_axi_gmem_ARQOS;
output  [3:0] m_axi_gmem_ARREGION;
output  [C_M_AXI_GMEM_ARUSER_WIDTH - 1:0] m_axi_gmem_ARUSER;
input   m_axi_gmem_RVALID;
output   m_axi_gmem_RREADY;
input  [C_M_AXI_GMEM_DATA_WIDTH - 1:0] m_axi_gmem_RDATA;
input   m_axi_gmem_RLAST;
input  [C_M_AXI_GMEM_ID_WIDTH - 1:0] m_axi_gmem_RID;
input  [C_M_AXI_GMEM_RUSER_WIDTH - 1:0] m_axi_gmem_RUSER;
input  [1:0] m_axi_gmem_RRESP;
input   m_axi_gmem_BVALID;
output   m_axi_gmem_BREADY;
input  [1:0] m_axi_gmem_BRESP;
input  [C_M_AXI_GMEM_ID_WIDTH - 1:0] m_axi_gmem_BID;
input  [C_M_AXI_GMEM_BUSER_WIDTH - 1:0] m_axi_gmem_BUSER;
input  [23:0] video_in_TDATA;
input   video_in_TVALID;
output   video_in_TREADY;
input  [2:0] video_in_TKEEP;
input  [2:0] video_in_TSTRB;
input  [0:0] video_in_TUSER;
input  [0:0] video_in_TLAST;
input  [0:0] video_in_TID;
input  [0:0] video_in_TDEST;
input   s_axi_AXILiteS_AWVALID;
output   s_axi_AXILiteS_AWREADY;
input  [C_S_AXI_AXILITES_ADDR_WIDTH - 1:0] s_axi_AXILiteS_AWADDR;
input   s_axi_AXILiteS_WVALID;
output   s_axi_AXILiteS_WREADY;
input  [C_S_AXI_AXILITES_DATA_WIDTH - 1:0] s_axi_AXILiteS_WDATA;
input  [C_S_AXI_AXILITES_WSTRB_WIDTH - 1:0] s_axi_AXILiteS_WSTRB;
input   s_axi_AXILiteS_ARVALID;
output   s_axi_AXILiteS_ARREADY;
input  [C_S_AXI_AXILITES_ADDR_WIDTH - 1:0] s_axi_AXILiteS_ARADDR;
output   s_axi_AXILiteS_RVALID;
input   s_axi_AXILiteS_RREADY;
output  [C_S_AXI_AXILITES_DATA_WIDTH - 1:0] s_axi_AXILiteS_RDATA;
output  [1:0] s_axi_AXILiteS_RRESP;
output   s_axi_AXILiteS_BVALID;
input   s_axi_AXILiteS_BREADY;
output  [1:0] s_axi_AXILiteS_BRESP;
output   interrupt;

reg video_in_TREADY;

 reg    ap_rst_n_inv;
wire    ap_start;
reg    ap_done;
reg    ap_idle;
(* fsm_encoding = "none" *) reg   [11:0] ap_CS_fsm;
wire    ap_CS_fsm_state1;
reg    ap_ready;
wire   [31:0] fb_out;
wire   [31:0] hsize;
wire   [31:0] vsize;
wire   [31:0] stride;
wire   [31:0] fsize;
reg    gmem_blk_n_AW;
wire    ap_CS_fsm_pp0_stage1;
reg    ap_enable_reg_pp0_iter2;
wire    ap_block_pp0_stage1;
reg   [0:0] tmp_24_reg_1027;
reg    gmem_blk_n_W;
wire    ap_CS_fsm_pp0_stage2;
wire    ap_block_pp0_stage2;
reg   [0:0] exitcond_flatten_reg_831;
reg   [0:0] exitcond_flatten_reg_831_pp0_iter2_reg;
reg    gmem_blk_n_B;
wire    ap_CS_fsm_pp0_stage7;
wire    ap_block_pp0_stage7;
reg   [0:0] tmp_26_reg_1042;
reg    video_in_TDATA_blk_n;
wire    ap_CS_fsm_state3;
wire   [0:0] tmp_nbreadreq_fu_146_p9;
reg    ap_enable_reg_pp0_iter0;
wire    ap_CS_fsm_pp0_stage3;
wire    ap_block_pp0_stage3;
wire    ap_CS_fsm_pp0_stage4;
wire    ap_block_pp0_stage4;
wire    ap_CS_fsm_pp0_stage5;
wire    ap_block_pp0_stage5;
wire    ap_CS_fsm_pp0_stage6;
wire    ap_block_pp0_stage6;
wire    ap_CS_fsm_pp0_stage0;
wire    ap_block_pp0_stage0;
wire   [0:0] exitcond_flatten_fu_326_p2;
reg   [0:0] ap_phi_mux_is_first_line_1_phi_fu_236_p4;
reg    gmem_AWVALID;
wire    gmem_AWREADY;
wire   [31:0] gmem_AWADDR;
reg    gmem_WVALID;
wire    gmem_WREADY;
wire    gmem_ARREADY;
wire    gmem_RVALID;
wire   [63:0] gmem_RDATA;
wire    gmem_RLAST;
wire   [0:0] gmem_RID;
wire   [0:0] gmem_RUSER;
wire   [1:0] gmem_RRESP;
wire    gmem_BVALID;
reg    gmem_BREADY;
wire   [1:0] gmem_BRESP;
wire   [0:0] gmem_BID;
wire   [0:0] gmem_BUSER;
reg   [12:0] indvar_flatten_reg_200;
reg    ap_predicate_op79_read_state4;
reg    ap_block_state4_pp0_stage0_iter0;
wire    ap_block_state12_pp0_stage0_iter1;
wire    ap_block_state20_pp0_stage0_iter2;
reg    ap_block_pp0_stage0_11001;
reg   [36:0] p_08_rec_reg_212;
reg   [23:0] pix_data_V_1_reg_223;
reg   [0:0] is_first_line_1_reg_232;
reg   [5:0] blk_idx_reg_245;
reg   [7:0] reg_291;
reg    ap_block_state5_pp0_stage1_iter0;
wire    ap_block_state13_pp0_stage1_iter1;
wire    ap_block_state21_pp0_stage1_iter2;
reg    ap_sig_ioackin_gmem_AWREADY;
reg    ap_block_state21_io;
reg    ap_block_pp0_stage1_11001;
reg    ap_block_state6_pp0_stage2_iter0;
wire    ap_block_state14_pp0_stage2_iter1;
wire    ap_block_state22_pp0_stage2_iter2;
reg    ap_sig_ioackin_gmem_WREADY;
reg    ap_block_state22_io;
reg    ap_block_pp0_stage2_11001;
reg    ap_block_state7_pp0_stage3_iter0;
wire    ap_block_state15_pp0_stage3_iter1;
wire    ap_block_state23_pp0_stage3_iter2;
reg    ap_block_pp0_stage3_11001;
reg    ap_block_state8_pp0_stage4_iter0;
wire    ap_block_state16_pp0_stage4_iter1;
wire    ap_block_state24_pp0_stage4_iter2;
reg    ap_block_pp0_stage4_11001;
reg    ap_block_state9_pp0_stage5_iter0;
wire    ap_block_state17_pp0_stage5_iter1;
wire    ap_block_state25_pp0_stage5_iter2;
reg    ap_block_pp0_stage5_11001;
reg    ap_block_state10_pp0_stage6_iter0;
wire    ap_block_state18_pp0_stage6_iter1;
wire    ap_block_state26_pp0_stage6_iter2;
reg    ap_block_pp0_stage6_11001;
reg    ap_block_state11_pp0_stage7_iter0;
wire    ap_block_state19_pp0_stage7_iter1;
reg    ap_block_state27_pp0_stage7_iter2;
reg    ap_block_pp0_stage7_11001;
reg   [31:0] stride_read_reg_803;
wire   [37:0] tmp_1_cast_fu_305_p1;
reg   [37:0] tmp_1_cast_reg_808;
reg    ap_block_state3;
wire   [0:0] tmp_user_V_fu_309_p1;
wire   [36:0] tmp_3_cast_fu_322_p1;
reg   [36:0] tmp_3_cast_reg_826;
reg   [0:0] exitcond_flatten_reg_831_pp0_iter1_reg;
wire   [12:0] indvar_flatten_next_fu_332_p2;
reg   [12:0] indvar_flatten_next_reg_835;
wire   [36:0] tmp_10_mid2_v_fu_349_p3;
reg   [36:0] tmp_10_mid2_v_reg_841;
wire   [7:0] tmp_15_fu_357_p1;
reg   [7:0] tmp_15_reg_847;
reg   [7:0] tmp_3_reg_852;
wire   [15:0] tmp_s_fu_385_p2;
reg   [15:0] tmp_s_reg_857;
wire   [5:0] blk_idx_1_fu_403_p3;
reg   [5:0] blk_idx_1_reg_862;
wire   [15:0] grp_fu_683_p3;
reg   [15:0] tmp1_reg_867;
wire   [7:0] tmp_16_fu_414_p1;
reg   [7:0] tmp_16_reg_872;
wire   [15:0] tmp_6_1_fu_422_p2;
reg   [15:0] tmp_6_1_reg_877;
reg   [7:0] y1_reg_882;
reg   [7:0] y1_reg_882_pp0_iter1_reg;
wire   [15:0] grp_fu_698_p3;
reg   [15:0] tmp2_reg_887;
wire   [7:0] tmp_17_fu_449_p1;
reg   [7:0] tmp_17_reg_892;
wire   [15:0] tmp_6_2_fu_457_p2;
reg   [15:0] tmp_6_2_reg_897;
reg   [7:0] y1_1_reg_902;
reg   [7:0] y1_1_reg_902_pp0_iter1_reg;
wire   [15:0] grp_fu_713_p3;
reg   [15:0] tmp3_reg_907;
wire   [7:0] tmp_18_fu_479_p1;
reg   [7:0] tmp_18_reg_912;
wire   [15:0] tmp_6_3_fu_487_p2;
reg   [15:0] tmp_6_3_reg_917;
reg   [7:0] y1_2_reg_922;
reg   [7:0] y1_2_reg_922_pp0_iter1_reg;
wire   [15:0] grp_fu_728_p3;
reg   [15:0] tmp4_reg_927;
wire   [7:0] tmp_19_fu_509_p1;
reg   [7:0] tmp_19_reg_932;
wire   [15:0] tmp_6_4_fu_517_p2;
reg   [15:0] tmp_6_4_reg_937;
reg   [7:0] y1_3_reg_942;
reg   [7:0] y1_3_reg_942_pp0_iter1_reg;
wire   [15:0] grp_fu_743_p3;
reg   [15:0] tmp5_reg_947;
wire   [7:0] tmp_20_fu_539_p1;
reg   [7:0] tmp_20_reg_952;
wire   [15:0] tmp_6_5_fu_547_p2;
reg   [15:0] tmp_6_5_reg_957;
reg   [7:0] y1_4_reg_962;
reg   [7:0] y1_4_reg_962_pp0_iter1_reg;
wire   [15:0] grp_fu_758_p3;
reg   [15:0] tmp6_reg_967;
wire   [7:0] tmp_21_fu_569_p1;
reg   [7:0] tmp_21_reg_972;
wire   [15:0] tmp_6_6_fu_577_p2;
reg   [15:0] tmp_6_6_reg_977;
reg   [7:0] y1_5_reg_982;
reg   [7:0] y1_5_reg_982_pp0_iter1_reg;
wire   [15:0] grp_fu_773_p3;
reg   [15:0] tmp7_reg_987;
reg   [23:0] tmp_data_V_7_reg_992;
wire   [7:0] tmp_22_fu_599_p1;
reg   [7:0] tmp_22_reg_997;
wire   [15:0] tmp_6_7_fu_607_p2;
reg   [15:0] tmp_6_7_reg_1002;
reg   [7:0] y1_6_reg_1007;
reg   [7:0] y1_6_reg_1007_pp0_iter2_reg;
wire   [15:0] grp_fu_788_p3;
reg   [15:0] tmp8_reg_1012;
reg    ap_enable_reg_pp0_iter1;
wire   [37:0] fb_out2_sum3_fu_632_p2;
reg   [37:0] fb_out2_sum3_reg_1017;
reg   [37:0] fb_out2_sum3_reg_1017_pp0_iter2_reg;
reg   [7:0] y1_7_reg_1022;
wire   [0:0] tmp_24_fu_649_p2;
wire   [63:0] blk_7_fu_655_p9;
reg   [63:0] blk_7_reg_1031;
wire   [0:0] tmp_26_fu_677_p2;
reg    ap_block_pp0_stage0_subdone;
reg    ap_condition_pp0_exit_iter0_state4;
reg    ap_block_pp0_stage7_subdone;
reg   [12:0] ap_phi_mux_indvar_flatten_phi_fu_204_p4;
reg   [36:0] ap_phi_mux_p_08_rec_phi_fu_216_p4;
reg   [23:0] ap_phi_mux_pix_data_V_1_phi_fu_226_p4;
reg   [5:0] ap_phi_mux_blk_idx_phi_fu_249_p4;
reg   [23:0] ap_phi_mux_pix_data_V_3_phi_fu_259_p4;
wire   [23:0] ap_phi_reg_pp0_iter0_pix_data_V_3_reg_256;
wire   [63:0] fb_out2_sum3_cast_fu_667_p1;
reg    ap_reg_ioackin_gmem_AWREADY;
reg    ap_block_pp0_stage1_01001;
reg    ap_reg_ioackin_gmem_WREADY;
reg    ap_block_pp0_stage2_01001;
wire   [28:0] tmp_1_fu_295_p4;
wire   [28:0] tmp_2_fu_313_p4;
wire   [0:0] tmp_5_fu_338_p2;
wire   [36:0] p_rec_dup4_fu_344_p2;
wire   [7:0] tmp_cast_fu_361_p4;
wire   [7:0] tmp_s_fu_385_p1;
wire   [6:0] grp_fu_391_p1;
wire   [5:0] blk_idx_op_fu_397_p2;
wire   [7:0] grp_fu_271_p4;
wire   [7:0] tmp_6_1_fu_422_p1;
wire   [6:0] grp_fu_428_p1;
wire   [15:0] grp_fu_690_p3;
wire   [7:0] tmp_6_2_fu_457_p1;
wire   [15:0] grp_fu_705_p3;
wire   [7:0] tmp_6_3_fu_487_p1;
wire   [15:0] grp_fu_720_p3;
wire   [7:0] tmp_6_4_fu_517_p1;
wire   [15:0] grp_fu_735_p3;
wire   [7:0] tmp_6_5_fu_547_p1;
wire   [15:0] grp_fu_750_p3;
wire   [7:0] tmp_6_6_fu_577_p1;
wire   [15:0] grp_fu_765_p3;
wire   [7:0] tmp_6_7_fu_607_p1;
wire   [15:0] grp_fu_780_p3;
wire   [37:0] tmp_10_mid2_cast_fu_613_p1;
wire   [15:0] grp_fu_795_p3;
wire   [12:0] grp_fu_391_p2;
wire   [12:0] grp_fu_428_p2;
wire   [7:0] grp_fu_683_p0;
wire   [7:0] grp_fu_683_p1;
wire   [5:0] grp_fu_690_p0;
wire   [7:0] grp_fu_690_p1;
wire   [7:0] grp_fu_698_p0;
wire   [7:0] grp_fu_698_p1;
wire   [5:0] grp_fu_705_p0;
wire   [7:0] grp_fu_705_p1;
wire   [7:0] grp_fu_713_p0;
wire   [7:0] grp_fu_713_p1;
wire   [5:0] grp_fu_720_p0;
wire   [7:0] grp_fu_720_p1;
wire   [7:0] grp_fu_728_p0;
wire   [7:0] grp_fu_728_p1;
wire   [5:0] grp_fu_735_p0;
wire   [7:0] grp_fu_735_p1;
wire   [7:0] grp_fu_743_p0;
wire   [7:0] grp_fu_743_p1;
wire   [5:0] grp_fu_750_p0;
wire   [7:0] grp_fu_750_p1;
wire   [7:0] grp_fu_758_p0;
wire   [7:0] grp_fu_758_p1;
wire   [5:0] grp_fu_765_p0;
wire   [7:0] grp_fu_765_p1;
wire   [7:0] grp_fu_773_p0;
wire   [7:0] grp_fu_773_p1;
wire   [5:0] grp_fu_780_p0;
wire   [7:0] grp_fu_780_p1;
wire   [7:0] grp_fu_788_p0;
wire   [7:0] grp_fu_788_p1;
wire   [5:0] grp_fu_795_p0;
wire   [7:0] grp_fu_795_p1;
reg    grp_fu_391_ce;
reg    grp_fu_428_ce;
wire    ap_CS_fsm_state28;
reg   [11:0] ap_NS_fsm;
reg    ap_block_pp0_stage1_subdone;
reg    ap_block_pp0_stage2_subdone;
reg    ap_block_pp0_stage3_subdone;
reg    ap_block_pp0_stage4_subdone;
reg    ap_block_pp0_stage5_subdone;
reg    ap_block_pp0_stage6_subdone;
reg    ap_idle_pp0;
wire    ap_enable_pp0;
wire   [15:0] grp_fu_683_p10;
wire   [13:0] grp_fu_690_p10;
wire   [15:0] grp_fu_698_p10;
wire   [13:0] grp_fu_705_p10;
wire   [15:0] grp_fu_713_p10;
wire   [13:0] grp_fu_720_p10;
wire   [15:0] grp_fu_728_p10;
wire   [13:0] grp_fu_735_p10;
wire   [15:0] grp_fu_743_p10;
wire   [13:0] grp_fu_750_p10;
wire   [15:0] grp_fu_758_p10;
wire   [13:0] grp_fu_765_p10;
wire   [15:0] grp_fu_773_p10;
wire   [13:0] grp_fu_780_p10;
wire   [15:0] grp_fu_788_p10;
wire   [13:0] grp_fu_795_p10;
wire   [15:0] tmp_6_1_fu_422_p10;
wire   [15:0] tmp_6_2_fu_457_p10;
wire   [15:0] tmp_6_3_fu_487_p10;
wire   [15:0] tmp_6_4_fu_517_p10;
wire   [15:0] tmp_6_5_fu_547_p10;
wire   [15:0] tmp_6_6_fu_577_p10;
wire   [15:0] tmp_6_7_fu_607_p10;
wire   [15:0] tmp_s_fu_385_p10;
reg    ap_condition_1201;
reg    ap_condition_1204;
reg    ap_condition_1208;
wire   [31:0] ap_return;

// power-on initialization
initial begin
#0 ap_CS_fsm = 12'd1;
#0 ap_enable_reg_pp0_iter2 = 1'b0;
#0 ap_enable_reg_pp0_iter0 = 1'b0;
#0 ap_enable_reg_pp0_iter1 = 1'b0;
#0 ap_reg_ioackin_gmem_AWREADY = 1'b0;
#0 ap_reg_ioackin_gmem_WREADY = 1'b0;
end

RGB2yfb_AXILiteS_s_axi #(
    .C_S_AXI_ADDR_WIDTH( C_S_AXI_AXILITES_ADDR_WIDTH ),
    .C_S_AXI_DATA_WIDTH( C_S_AXI_AXILITES_DATA_WIDTH ))
RGB2yfb_AXILiteS_s_axi_U(
    .AWVALID(s_axi_AXILiteS_AWVALID),
    .AWREADY(s_axi_AXILiteS_AWREADY),
    .AWADDR(s_axi_AXILiteS_AWADDR),
    .WVALID(s_axi_AXILiteS_WVALID),
    .WREADY(s_axi_AXILiteS_WREADY),
    .WDATA(s_axi_AXILiteS_WDATA),
    .WSTRB(s_axi_AXILiteS_WSTRB),
    .ARVALID(s_axi_AXILiteS_ARVALID),
    .ARREADY(s_axi_AXILiteS_ARREADY),
    .ARADDR(s_axi_AXILiteS_ARADDR),
    .RVALID(s_axi_AXILiteS_RVALID),
    .RREADY(s_axi_AXILiteS_RREADY),
    .RDATA(s_axi_AXILiteS_RDATA),
    .RRESP(s_axi_AXILiteS_RRESP),
    .BVALID(s_axi_AXILiteS_BVALID),
    .BREADY(s_axi_AXILiteS_BREADY),
    .BRESP(s_axi_AXILiteS_BRESP),
    .ACLK(ap_clk),
    .ARESET(ap_rst_n_inv),
    .ACLK_EN(1'b1),
    .ap_start(ap_start),
    .interrupt(interrupt),
    .ap_ready(ap_ready),
    .ap_done(ap_done),
    .ap_idle(ap_idle),
    .ap_return(32'd0),
    .fb_out(fb_out),
    .hsize(hsize),
    .vsize(vsize),
    .stride(stride),
    .fsize(fsize)
);

RGB2yfb_gmem_m_axi #(
    .CONSERVATIVE( 0 ),
    .USER_DW( 64 ),
    .USER_AW( 32 ),
    .USER_MAXREQS( 5 ),
    .NUM_READ_OUTSTANDING( 16 ),
    .NUM_WRITE_OUTSTANDING( 16 ),
    .MAX_READ_BURST_LENGTH( 16 ),
    .MAX_WRITE_BURST_LENGTH( 16 ),
    .C_M_AXI_ID_WIDTH( C_M_AXI_GMEM_ID_WIDTH ),
    .C_M_AXI_ADDR_WIDTH( C_M_AXI_GMEM_ADDR_WIDTH ),
    .C_M_AXI_DATA_WIDTH( C_M_AXI_GMEM_DATA_WIDTH ),
    .C_M_AXI_AWUSER_WIDTH( C_M_AXI_GMEM_AWUSER_WIDTH ),
    .C_M_AXI_ARUSER_WIDTH( C_M_AXI_GMEM_ARUSER_WIDTH ),
    .C_M_AXI_WUSER_WIDTH( C_M_AXI_GMEM_WUSER_WIDTH ),
    .C_M_AXI_RUSER_WIDTH( C_M_AXI_GMEM_RUSER_WIDTH ),
    .C_M_AXI_BUSER_WIDTH( C_M_AXI_GMEM_BUSER_WIDTH ),
    .C_USER_VALUE( C_M_AXI_GMEM_USER_VALUE ),
    .C_PROT_VALUE( C_M_AXI_GMEM_PROT_VALUE ),
    .C_CACHE_VALUE( C_M_AXI_GMEM_CACHE_VALUE ))
RGB2yfb_gmem_m_axi_U(
    .AWVALID(m_axi_gmem_AWVALID),
    .AWREADY(m_axi_gmem_AWREADY),
    .AWADDR(m_axi_gmem_AWADDR),
    .AWID(m_axi_gmem_AWID),
    .AWLEN(m_axi_gmem_AWLEN),
    .AWSIZE(m_axi_gmem_AWSIZE),
    .AWBURST(m_axi_gmem_AWBURST),
    .AWLOCK(m_axi_gmem_AWLOCK),
    .AWCACHE(m_axi_gmem_AWCACHE),
    .AWPROT(m_axi_gmem_AWPROT),
    .AWQOS(m_axi_gmem_AWQOS),
    .AWREGION(m_axi_gmem_AWREGION),
    .AWUSER(m_axi_gmem_AWUSER),
    .WVALID(m_axi_gmem_WVALID),
    .WREADY(m_axi_gmem_WREADY),
    .WDATA(m_axi_gmem_WDATA),
    .WSTRB(m_axi_gmem_WSTRB),
    .WLAST(m_axi_gmem_WLAST),
    .WID(m_axi_gmem_WID),
    .WUSER(m_axi_gmem_WUSER),
    .ARVALID(m_axi_gmem_ARVALID),
    .ARREADY(m_axi_gmem_ARREADY),
    .ARADDR(m_axi_gmem_ARADDR),
    .ARID(m_axi_gmem_ARID),
    .ARLEN(m_axi_gmem_ARLEN),
    .ARSIZE(m_axi_gmem_ARSIZE),
    .ARBURST(m_axi_gmem_ARBURST),
    .ARLOCK(m_axi_gmem_ARLOCK),
    .ARCACHE(m_axi_gmem_ARCACHE),
    .ARPROT(m_axi_gmem_ARPROT),
    .ARQOS(m_axi_gmem_ARQOS),
    .ARREGION(m_axi_gmem_ARREGION),
    .ARUSER(m_axi_gmem_ARUSER),
    .RVALID(m_axi_gmem_RVALID),
    .RREADY(m_axi_gmem_RREADY),
    .RDATA(m_axi_gmem_RDATA),
    .RLAST(m_axi_gmem_RLAST),
    .RID(m_axi_gmem_RID),
    .RUSER(m_axi_gmem_RUSER),
    .RRESP(m_axi_gmem_RRESP),
    .BVALID(m_axi_gmem_BVALID),
    .BREADY(m_axi_gmem_BREADY),
    .BRESP(m_axi_gmem_BRESP),
    .BID(m_axi_gmem_BID),
    .BUSER(m_axi_gmem_BUSER),
    .ACLK(ap_clk),
    .ARESET(ap_rst_n_inv),
    .ACLK_EN(1'b1),
    .I_ARVALID(1'b0),
    .I_ARREADY(gmem_ARREADY),
    .I_ARADDR(32'd0),
    .I_ARID(1'd0),
    .I_ARLEN(32'd0),
    .I_ARSIZE(3'd0),
    .I_ARLOCK(2'd0),
    .I_ARCACHE(4'd0),
    .I_ARQOS(4'd0),
    .I_ARPROT(3'd0),
    .I_ARUSER(1'd0),
    .I_ARBURST(2'd0),
    .I_ARREGION(4'd0),
    .I_RVALID(gmem_RVALID),
    .I_RREADY(1'b0),
    .I_RDATA(gmem_RDATA),
    .I_RID(gmem_RID),
    .I_RUSER(gmem_RUSER),
    .I_RRESP(gmem_RRESP),
    .I_RLAST(gmem_RLAST),
    .I_AWVALID(gmem_AWVALID),
    .I_AWREADY(gmem_AWREADY),
    .I_AWADDR(gmem_AWADDR),
    .I_AWID(1'd0),
    .I_AWLEN(32'd40),
    .I_AWSIZE(3'd0),
    .I_AWLOCK(2'd0),
    .I_AWCACHE(4'd0),
    .I_AWQOS(4'd0),
    .I_AWPROT(3'd0),
    .I_AWUSER(1'd0),
    .I_AWBURST(2'd0),
    .I_AWREGION(4'd0),
    .I_WVALID(gmem_WVALID),
    .I_WREADY(gmem_WREADY),
    .I_WDATA(blk_7_reg_1031),
    .I_WID(1'd0),
    .I_WUSER(1'd0),
    .I_WLAST(1'b0),
    .I_WSTRB(8'd255),
    .I_BVALID(gmem_BVALID),
    .I_BREADY(gmem_BREADY),
    .I_BRESP(gmem_BRESP),
    .I_BID(gmem_BID),
    .I_BUSER(gmem_BUSER)
);

RGB2yfb_urem_13nsbkb #(
    .ID( 1 ),
    .NUM_STAGE( 17 ),
    .din0_WIDTH( 13 ),
    .din1_WIDTH( 7 ),
    .dout_WIDTH( 13 ))
RGB2yfb_urem_13nsbkb_U1(
    .clk(ap_clk),
    .reset(ap_rst_n_inv),
    .din0(ap_phi_mux_indvar_flatten_phi_fu_204_p4),
    .din1(grp_fu_391_p1),
    .ce(grp_fu_391_ce),
    .dout(grp_fu_391_p2)
);

RGB2yfb_urem_13nsbkb #(
    .ID( 1 ),
    .NUM_STAGE( 17 ),
    .din0_WIDTH( 13 ),
    .din1_WIDTH( 7 ),
    .dout_WIDTH( 13 ))
RGB2yfb_urem_13nsbkb_U2(
    .clk(ap_clk),
    .reset(ap_rst_n_inv),
    .din0(indvar_flatten_next_reg_835),
    .din1(grp_fu_428_p1),
    .ce(grp_fu_428_ce),
    .dout(grp_fu_428_p2)
);

RGB2yfb_mac_muladcud #(
    .ID( 1 ),
    .NUM_STAGE( 1 ),
    .din0_WIDTH( 8 ),
    .din1_WIDTH( 8 ),
    .din2_WIDTH( 16 ),
    .dout_WIDTH( 16 ))
RGB2yfb_mac_muladcud_U3(
    .din0(grp_fu_683_p0),
    .din1(grp_fu_683_p1),
    .din2(tmp_s_reg_857),
    .dout(grp_fu_683_p3)
);

RGB2yfb_mac_muladdEe #(
    .ID( 1 ),
    .NUM_STAGE( 1 ),
    .din0_WIDTH( 6 ),
    .din1_WIDTH( 8 ),
    .din2_WIDTH( 16 ),
    .dout_WIDTH( 16 ))
RGB2yfb_mac_muladdEe_U4(
    .din0(grp_fu_690_p0),
    .din1(grp_fu_690_p1),
    .din2(tmp1_reg_867),
    .dout(grp_fu_690_p3)
);

RGB2yfb_mac_muladcud #(
    .ID( 1 ),
    .NUM_STAGE( 1 ),
    .din0_WIDTH( 8 ),
    .din1_WIDTH( 8 ),
    .din2_WIDTH( 16 ),
    .dout_WIDTH( 16 ))
RGB2yfb_mac_muladcud_U5(
    .din0(grp_fu_698_p0),
    .din1(grp_fu_698_p1),
    .din2(tmp_6_1_reg_877),
    .dout(grp_fu_698_p3)
);

RGB2yfb_mac_muladdEe #(
    .ID( 1 ),
    .NUM_STAGE( 1 ),
    .din0_WIDTH( 6 ),
    .din1_WIDTH( 8 ),
    .din2_WIDTH( 16 ),
    .dout_WIDTH( 16 ))
RGB2yfb_mac_muladdEe_U6(
    .din0(grp_fu_705_p0),
    .din1(grp_fu_705_p1),
    .din2(tmp2_reg_887),
    .dout(grp_fu_705_p3)
);

RGB2yfb_mac_muladcud #(
    .ID( 1 ),
    .NUM_STAGE( 1 ),
    .din0_WIDTH( 8 ),
    .din1_WIDTH( 8 ),
    .din2_WIDTH( 16 ),
    .dout_WIDTH( 16 ))
RGB2yfb_mac_muladcud_U7(
    .din0(grp_fu_713_p0),
    .din1(grp_fu_713_p1),
    .din2(tmp_6_2_reg_897),
    .dout(grp_fu_713_p3)
);

RGB2yfb_mac_muladdEe #(
    .ID( 1 ),
    .NUM_STAGE( 1 ),
    .din0_WIDTH( 6 ),
    .din1_WIDTH( 8 ),
    .din2_WIDTH( 16 ),
    .dout_WIDTH( 16 ))
RGB2yfb_mac_muladdEe_U8(
    .din0(grp_fu_720_p0),
    .din1(grp_fu_720_p1),
    .din2(tmp3_reg_907),
    .dout(grp_fu_720_p3)
);

RGB2yfb_mac_muladcud #(
    .ID( 1 ),
    .NUM_STAGE( 1 ),
    .din0_WIDTH( 8 ),
    .din1_WIDTH( 8 ),
    .din2_WIDTH( 16 ),
    .dout_WIDTH( 16 ))
RGB2yfb_mac_muladcud_U9(
    .din0(grp_fu_728_p0),
    .din1(grp_fu_728_p1),
    .din2(tmp_6_3_reg_917),
    .dout(grp_fu_728_p3)
);

RGB2yfb_mac_muladdEe #(
    .ID( 1 ),
    .NUM_STAGE( 1 ),
    .din0_WIDTH( 6 ),
    .din1_WIDTH( 8 ),
    .din2_WIDTH( 16 ),
    .dout_WIDTH( 16 ))
RGB2yfb_mac_muladdEe_U10(
    .din0(grp_fu_735_p0),
    .din1(grp_fu_735_p1),
    .din2(tmp4_reg_927),
    .dout(grp_fu_735_p3)
);

RGB2yfb_mac_muladcud #(
    .ID( 1 ),
    .NUM_STAGE( 1 ),
    .din0_WIDTH( 8 ),
    .din1_WIDTH( 8 ),
    .din2_WIDTH( 16 ),
    .dout_WIDTH( 16 ))
RGB2yfb_mac_muladcud_U11(
    .din0(grp_fu_743_p0),
    .din1(grp_fu_743_p1),
    .din2(tmp_6_4_reg_937),
    .dout(grp_fu_743_p3)
);

RGB2yfb_mac_muladdEe #(
    .ID( 1 ),
    .NUM_STAGE( 1 ),
    .din0_WIDTH( 6 ),
    .din1_WIDTH( 8 ),
    .din2_WIDTH( 16 ),
    .dout_WIDTH( 16 ))
RGB2yfb_mac_muladdEe_U12(
    .din0(grp_fu_750_p0),
    .din1(grp_fu_750_p1),
    .din2(tmp5_reg_947),
    .dout(grp_fu_750_p3)
);

RGB2yfb_mac_muladcud #(
    .ID( 1 ),
    .NUM_STAGE( 1 ),
    .din0_WIDTH( 8 ),
    .din1_WIDTH( 8 ),
    .din2_WIDTH( 16 ),
    .dout_WIDTH( 16 ))
RGB2yfb_mac_muladcud_U13(
    .din0(grp_fu_758_p0),
    .din1(grp_fu_758_p1),
    .din2(tmp_6_5_reg_957),
    .dout(grp_fu_758_p3)
);

RGB2yfb_mac_muladdEe #(
    .ID( 1 ),
    .NUM_STAGE( 1 ),
    .din0_WIDTH( 6 ),
    .din1_WIDTH( 8 ),
    .din2_WIDTH( 16 ),
    .dout_WIDTH( 16 ))
RGB2yfb_mac_muladdEe_U14(
    .din0(grp_fu_765_p0),
    .din1(grp_fu_765_p1),
    .din2(tmp6_reg_967),
    .dout(grp_fu_765_p3)
);

RGB2yfb_mac_muladcud #(
    .ID( 1 ),
    .NUM_STAGE( 1 ),
    .din0_WIDTH( 8 ),
    .din1_WIDTH( 8 ),
    .din2_WIDTH( 16 ),
    .dout_WIDTH( 16 ))
RGB2yfb_mac_muladcud_U15(
    .din0(grp_fu_773_p0),
    .din1(grp_fu_773_p1),
    .din2(tmp_6_6_reg_977),
    .dout(grp_fu_773_p3)
);

RGB2yfb_mac_muladdEe #(
    .ID( 1 ),
    .NUM_STAGE( 1 ),
    .din0_WIDTH( 6 ),
    .din1_WIDTH( 8 ),
    .din2_WIDTH( 16 ),
    .dout_WIDTH( 16 ))
RGB2yfb_mac_muladdEe_U16(
    .din0(grp_fu_780_p0),
    .din1(grp_fu_780_p1),
    .din2(tmp7_reg_987),
    .dout(grp_fu_780_p3)
);

RGB2yfb_mac_muladcud #(
    .ID( 1 ),
    .NUM_STAGE( 1 ),
    .din0_WIDTH( 8 ),
    .din1_WIDTH( 8 ),
    .din2_WIDTH( 16 ),
    .dout_WIDTH( 16 ))
RGB2yfb_mac_muladcud_U17(
    .din0(grp_fu_788_p0),
    .din1(grp_fu_788_p1),
    .din2(tmp_6_7_reg_1002),
    .dout(grp_fu_788_p3)
);

RGB2yfb_mac_muladdEe #(
    .ID( 1 ),
    .NUM_STAGE( 1 ),
    .din0_WIDTH( 6 ),
    .din1_WIDTH( 8 ),
    .din2_WIDTH( 16 ),
    .dout_WIDTH( 16 ))
RGB2yfb_mac_muladdEe_U18(
    .din0(grp_fu_795_p0),
    .din1(grp_fu_795_p1),
    .din2(tmp8_reg_1012),
    .dout(grp_fu_795_p3)
);

always @ (posedge ap_clk) begin
    if (ap_rst_n_inv == 1'b1) begin
        ap_CS_fsm <= ap_ST_fsm_state1;
    end else begin
        ap_CS_fsm <= ap_NS_fsm;
    end
end

always @ (posedge ap_clk) begin
    if (ap_rst_n_inv == 1'b1) begin
        ap_enable_reg_pp0_iter0 <= 1'b0;
    end else begin
        if (((1'b0 == ap_block_pp0_stage0_subdone) & (1'b1 == ap_condition_pp0_exit_iter0_state4) & (1'b1 == ap_CS_fsm_pp0_stage0))) begin
            ap_enable_reg_pp0_iter0 <= 1'b0;
        end else if ((~((video_in_TVALID == 1'b0) & (tmp_nbreadreq_fu_146_p9 == 1'd1)) & (1'b1 == ap_CS_fsm_state3) & (tmp_user_V_fu_309_p1 == 1'd1) & (tmp_nbreadreq_fu_146_p9 == 1'd1))) begin
            ap_enable_reg_pp0_iter0 <= 1'b1;
        end
    end
end

always @ (posedge ap_clk) begin
    if (ap_rst_n_inv == 1'b1) begin
        ap_enable_reg_pp0_iter1 <= 1'b0;
    end else begin
        if (((1'b0 == ap_block_pp0_stage7_subdone) & (1'b1 == ap_CS_fsm_pp0_stage7))) begin
            ap_enable_reg_pp0_iter1 <= ap_enable_reg_pp0_iter0;
        end
    end
end

always @ (posedge ap_clk) begin
    if (ap_rst_n_inv == 1'b1) begin
        ap_enable_reg_pp0_iter2 <= 1'b0;
    end else begin
        if (((1'b0 == ap_block_pp0_stage7_subdone) & (1'b1 == ap_CS_fsm_pp0_stage7))) begin
            ap_enable_reg_pp0_iter2 <= ap_enable_reg_pp0_iter1;
        end else if ((~((video_in_TVALID == 1'b0) & (tmp_nbreadreq_fu_146_p9 == 1'd1)) & (1'b1 == ap_CS_fsm_state3) & (tmp_user_V_fu_309_p1 == 1'd1) & (tmp_nbreadreq_fu_146_p9 == 1'd1))) begin
            ap_enable_reg_pp0_iter2 <= 1'b0;
        end
    end
end

always @ (posedge ap_clk) begin
    if (ap_rst_n_inv == 1'b1) begin
        ap_reg_ioackin_gmem_AWREADY <= 1'b0;
    end else begin
        if ((1'b1 == ap_condition_1204)) begin
            if ((1'b0 == ap_block_pp0_stage1_11001)) begin
                ap_reg_ioackin_gmem_AWREADY <= 1'b0;
            end else if (((1'b0 == ap_block_pp0_stage1_01001) & (gmem_AWREADY == 1'b1))) begin
                ap_reg_ioackin_gmem_AWREADY <= 1'b1;
            end
        end
    end
end

always @ (posedge ap_clk) begin
    if (ap_rst_n_inv == 1'b1) begin
        ap_reg_ioackin_gmem_WREADY <= 1'b0;
    end else begin
        if ((1'b1 == ap_condition_1208)) begin
            if ((1'b0 == ap_block_pp0_stage2_11001)) begin
                ap_reg_ioackin_gmem_WREADY <= 1'b0;
            end else if (((1'b0 == ap_block_pp0_stage2_01001) & (gmem_WREADY == 1'b1))) begin
                ap_reg_ioackin_gmem_WREADY <= 1'b1;
            end
        end
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage0_11001) & (ap_enable_reg_pp0_iter1 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage0) & (exitcond_flatten_reg_831 == 1'd0))) begin
        blk_idx_reg_245 <= blk_idx_1_reg_862;
    end else if ((~((video_in_TVALID == 1'b0) & (tmp_nbreadreq_fu_146_p9 == 1'd1)) & (1'b1 == ap_CS_fsm_state3) & (tmp_user_V_fu_309_p1 == 1'd1) & (tmp_nbreadreq_fu_146_p9 == 1'd1))) begin
        blk_idx_reg_245 <= 6'd0;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage0_11001) & (ap_enable_reg_pp0_iter1 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage0) & (exitcond_flatten_reg_831 == 1'd0))) begin
        indvar_flatten_reg_200 <= indvar_flatten_next_reg_835;
    end else if ((~((video_in_TVALID == 1'b0) & (tmp_nbreadreq_fu_146_p9 == 1'd1)) & (1'b1 == ap_CS_fsm_state3) & (tmp_user_V_fu_309_p1 == 1'd1) & (tmp_nbreadreq_fu_146_p9 == 1'd1))) begin
        indvar_flatten_reg_200 <= 13'd0;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage0_11001) & (ap_enable_reg_pp0_iter1 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage0) & (exitcond_flatten_reg_831 == 1'd0))) begin
        is_first_line_1_reg_232 <= 1'd0;
    end else if ((~((video_in_TVALID == 1'b0) & (tmp_nbreadreq_fu_146_p9 == 1'd1)) & (1'b1 == ap_CS_fsm_state3) & (tmp_user_V_fu_309_p1 == 1'd1) & (tmp_nbreadreq_fu_146_p9 == 1'd1))) begin
        is_first_line_1_reg_232 <= 1'd1;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage0_11001) & (ap_enable_reg_pp0_iter1 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage0) & (exitcond_flatten_reg_831 == 1'd0))) begin
        p_08_rec_reg_212 <= tmp_10_mid2_v_reg_841;
    end else if ((~((video_in_TVALID == 1'b0) & (tmp_nbreadreq_fu_146_p9 == 1'd1)) & (1'b1 == ap_CS_fsm_state3) & (tmp_user_V_fu_309_p1 == 1'd1) & (tmp_nbreadreq_fu_146_p9 == 1'd1))) begin
        p_08_rec_reg_212 <= 37'd0;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage0_11001) & (ap_enable_reg_pp0_iter1 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage0) & (exitcond_flatten_reg_831 == 1'd0))) begin
        pix_data_V_1_reg_223 <= tmp_data_V_7_reg_992;
    end else if ((~((video_in_TVALID == 1'b0) & (tmp_nbreadreq_fu_146_p9 == 1'd1)) & (1'b1 == ap_CS_fsm_state3) & (tmp_user_V_fu_309_p1 == 1'd1) & (tmp_nbreadreq_fu_146_p9 == 1'd1))) begin
        pix_data_V_1_reg_223 <= video_in_TDATA;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage1_11001) & (1'b1 == ap_CS_fsm_pp0_stage1) & (exitcond_flatten_reg_831_pp0_iter2_reg == 1'd0))) begin
        blk_7_reg_1031 <= blk_7_fu_655_p9;
        tmp_26_reg_1042 <= tmp_26_fu_677_p2;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage0_11001) & (1'b1 == ap_CS_fsm_pp0_stage0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_fu_326_p2 == 1'd0))) begin
        blk_idx_1_reg_862 <= blk_idx_1_fu_403_p3;
        tmp_10_mid2_v_reg_841 <= tmp_10_mid2_v_fu_349_p3;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage0_11001) & (1'b1 == ap_CS_fsm_pp0_stage0))) begin
        exitcond_flatten_reg_831 <= exitcond_flatten_fu_326_p2;
        exitcond_flatten_reg_831_pp0_iter1_reg <= exitcond_flatten_reg_831;
        exitcond_flatten_reg_831_pp0_iter2_reg <= exitcond_flatten_reg_831_pp0_iter1_reg;
        fb_out2_sum3_reg_1017_pp0_iter2_reg <= fb_out2_sum3_reg_1017;
        y1_6_reg_1007_pp0_iter2_reg <= y1_6_reg_1007;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage0_11001) & (1'b1 == ap_CS_fsm_pp0_stage0) & (exitcond_flatten_reg_831 == 1'd0))) begin
        fb_out2_sum3_reg_1017 <= fb_out2_sum3_fu_632_p2;
        y1_6_reg_1007 <= {{grp_fu_780_p3[15:8]}};
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage0_11001) & (1'b1 == ap_CS_fsm_pp0_stage0) & (ap_enable_reg_pp0_iter0 == 1'b1))) begin
        indvar_flatten_next_reg_835 <= indvar_flatten_next_fu_332_p2;
    end
end

always @ (posedge ap_clk) begin
    if ((((1'b0 == ap_block_pp0_stage6_11001) & (1'b1 == ap_CS_fsm_pp0_stage6) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_831 == 1'd0)) | ((1'b0 == ap_block_pp0_stage5_11001) & (1'b1 == ap_CS_fsm_pp0_stage5) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_831 == 1'd0)) | ((1'b0 == ap_block_pp0_stage4_11001) & (1'b1 == ap_CS_fsm_pp0_stage4) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_831 == 1'd0)) | ((1'b0 == ap_block_pp0_stage3_11001) & (1'b1 == ap_CS_fsm_pp0_stage3) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_831 == 1'd0)) | ((1'b0 == ap_block_pp0_stage7_11001) & (ap_enable_reg_pp0_iter0 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage7) & (exitcond_flatten_reg_831 == 1'd0)) | ((1'b0 == ap_block_pp0_stage2_11001) & (ap_enable_reg_pp0_iter0 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage2) & (exitcond_flatten_reg_831 == 1'd0)) | ((1'b0 == ap_block_pp0_stage1_11001) & (ap_enable_reg_pp0_iter0 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage1) & (exitcond_flatten_reg_831 == 1'd0)))) begin
        reg_291 <= {{video_in_TDATA[23:16]}};
    end
end

always @ (posedge ap_clk) begin
    if (((1'b1 == ap_CS_fsm_state1) & (ap_start == 1'b1))) begin
        stride_read_reg_803 <= stride;
        tmp_1_cast_reg_808[28 : 0] <= tmp_1_cast_fu_305_p1[28 : 0];
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage1_11001) & (ap_enable_reg_pp0_iter0 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage1) & (exitcond_flatten_reg_831 == 1'd0))) begin
        tmp1_reg_867 <= grp_fu_683_p3;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage2_11001) & (ap_enable_reg_pp0_iter0 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage2) & (exitcond_flatten_reg_831 == 1'd0))) begin
        tmp2_reg_887 <= grp_fu_698_p3;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage3_11001) & (1'b1 == ap_CS_fsm_pp0_stage3) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_831 == 1'd0))) begin
        tmp3_reg_907 <= grp_fu_713_p3;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage4_11001) & (1'b1 == ap_CS_fsm_pp0_stage4) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_831 == 1'd0))) begin
        tmp4_reg_927 <= grp_fu_728_p3;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage5_11001) & (1'b1 == ap_CS_fsm_pp0_stage5) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_831 == 1'd0))) begin
        tmp5_reg_947 <= grp_fu_743_p3;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage6_11001) & (1'b1 == ap_CS_fsm_pp0_stage6) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_831 == 1'd0))) begin
        tmp6_reg_967 <= grp_fu_758_p3;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage7_11001) & (ap_enable_reg_pp0_iter0 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage7) & (exitcond_flatten_reg_831 == 1'd0))) begin
        tmp7_reg_987 <= grp_fu_773_p3;
        tmp_data_V_7_reg_992 <= video_in_TDATA;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage0_11001) & (ap_enable_reg_pp0_iter1 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage0) & (exitcond_flatten_reg_831 == 1'd0))) begin
        tmp8_reg_1012 <= grp_fu_788_p3;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage0_11001) & (1'b1 == ap_CS_fsm_pp0_stage0) & (exitcond_flatten_fu_326_p2 == 1'd0))) begin
        tmp_15_reg_847 <= tmp_15_fu_357_p1;
        tmp_3_reg_852 <= {{ap_phi_mux_pix_data_V_3_phi_fu_259_p4[23:16]}};
        tmp_s_reg_857 <= tmp_s_fu_385_p2;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage1_11001) & (1'b1 == ap_CS_fsm_pp0_stage1) & (exitcond_flatten_reg_831 == 1'd0))) begin
        tmp_16_reg_872 <= tmp_16_fu_414_p1;
        tmp_6_1_reg_877 <= tmp_6_1_fu_422_p2;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage2_11001) & (1'b1 == ap_CS_fsm_pp0_stage2) & (exitcond_flatten_reg_831 == 1'd0))) begin
        tmp_17_reg_892 <= tmp_17_fu_449_p1;
        tmp_6_2_reg_897 <= tmp_6_2_fu_457_p2;
        y1_reg_882 <= {{grp_fu_690_p3[15:8]}};
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage3_11001) & (1'b1 == ap_CS_fsm_pp0_stage3) & (exitcond_flatten_reg_831 == 1'd0))) begin
        tmp_18_reg_912 <= tmp_18_fu_479_p1;
        tmp_6_3_reg_917 <= tmp_6_3_fu_487_p2;
        y1_1_reg_902 <= {{grp_fu_705_p3[15:8]}};
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage4_11001) & (1'b1 == ap_CS_fsm_pp0_stage4) & (exitcond_flatten_reg_831 == 1'd0))) begin
        tmp_19_reg_932 <= tmp_19_fu_509_p1;
        tmp_6_4_reg_937 <= tmp_6_4_fu_517_p2;
        y1_2_reg_922 <= {{grp_fu_720_p3[15:8]}};
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage5_11001) & (1'b1 == ap_CS_fsm_pp0_stage5) & (exitcond_flatten_reg_831 == 1'd0))) begin
        tmp_20_reg_952 <= tmp_20_fu_539_p1;
        tmp_6_5_reg_957 <= tmp_6_5_fu_547_p2;
        y1_3_reg_942 <= {{grp_fu_735_p3[15:8]}};
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage6_11001) & (1'b1 == ap_CS_fsm_pp0_stage6) & (exitcond_flatten_reg_831 == 1'd0))) begin
        tmp_21_reg_972 <= tmp_21_fu_569_p1;
        tmp_6_6_reg_977 <= tmp_6_6_fu_577_p2;
        y1_4_reg_962 <= {{grp_fu_750_p3[15:8]}};
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage7_11001) & (1'b1 == ap_CS_fsm_pp0_stage7) & (exitcond_flatten_reg_831 == 1'd0))) begin
        tmp_22_reg_997 <= tmp_22_fu_599_p1;
        tmp_6_7_reg_1002 <= tmp_6_7_fu_607_p2;
        y1_5_reg_982 <= {{grp_fu_765_p3[15:8]}};
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage0_11001) & (1'b1 == ap_CS_fsm_pp0_stage0) & (exitcond_flatten_reg_831_pp0_iter1_reg == 1'd0))) begin
        tmp_24_reg_1027 <= tmp_24_fu_649_p2;
    end
end

always @ (posedge ap_clk) begin
    if ((~((video_in_TVALID == 1'b0) & (tmp_nbreadreq_fu_146_p9 == 1'd1)) & (1'b1 == ap_CS_fsm_state3) & (tmp_user_V_fu_309_p1 == 1'd1) & (tmp_nbreadreq_fu_146_p9 == 1'd1))) begin
        tmp_3_cast_reg_826[28 : 0] <= tmp_3_cast_fu_322_p1[28 : 0];
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage3_11001) & (1'b1 == ap_CS_fsm_pp0_stage3))) begin
        y1_1_reg_902_pp0_iter1_reg <= y1_1_reg_902;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage4_11001) & (1'b1 == ap_CS_fsm_pp0_stage4))) begin
        y1_2_reg_922_pp0_iter1_reg <= y1_2_reg_922;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage5_11001) & (1'b1 == ap_CS_fsm_pp0_stage5))) begin
        y1_3_reg_942_pp0_iter1_reg <= y1_3_reg_942;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage6_11001) & (1'b1 == ap_CS_fsm_pp0_stage6))) begin
        y1_4_reg_962_pp0_iter1_reg <= y1_4_reg_962;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage7_11001) & (1'b1 == ap_CS_fsm_pp0_stage7))) begin
        y1_5_reg_982_pp0_iter1_reg <= y1_5_reg_982;
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage1_11001) & (1'b1 == ap_CS_fsm_pp0_stage1) & (exitcond_flatten_reg_831_pp0_iter1_reg == 1'd0))) begin
        y1_7_reg_1022 <= {{grp_fu_795_p3[15:8]}};
    end
end

always @ (posedge ap_clk) begin
    if (((1'b0 == ap_block_pp0_stage2_11001) & (1'b1 == ap_CS_fsm_pp0_stage2))) begin
        y1_reg_882_pp0_iter1_reg <= y1_reg_882;
    end
end

always @ (*) begin
    if ((exitcond_flatten_fu_326_p2 == 1'd1)) begin
        ap_condition_pp0_exit_iter0_state4 = 1'b1;
    end else begin
        ap_condition_pp0_exit_iter0_state4 = 1'b0;
    end
end

always @ (*) begin
    if ((1'b1 == ap_CS_fsm_state28)) begin
        ap_done = 1'b1;
    end else begin
        ap_done = 1'b0;
    end
end

always @ (*) begin
    if (((ap_start == 1'b0) & (1'b1 == ap_CS_fsm_state1))) begin
        ap_idle = 1'b1;
    end else begin
        ap_idle = 1'b0;
    end
end

always @ (*) begin
    if (((ap_enable_reg_pp0_iter1 == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b0) & (ap_enable_reg_pp0_iter2 == 1'b0))) begin
        ap_idle_pp0 = 1'b1;
    end else begin
        ap_idle_pp0 = 1'b0;
    end
end

always @ (*) begin
    if (((1'b0 == ap_block_pp0_stage0) & (ap_enable_reg_pp0_iter1 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage0) & (exitcond_flatten_reg_831 == 1'd0))) begin
        ap_phi_mux_blk_idx_phi_fu_249_p4 = blk_idx_1_reg_862;
    end else begin
        ap_phi_mux_blk_idx_phi_fu_249_p4 = blk_idx_reg_245;
    end
end

always @ (*) begin
    if (((1'b0 == ap_block_pp0_stage0) & (ap_enable_reg_pp0_iter1 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage0) & (exitcond_flatten_reg_831 == 1'd0))) begin
        ap_phi_mux_indvar_flatten_phi_fu_204_p4 = indvar_flatten_next_reg_835;
    end else begin
        ap_phi_mux_indvar_flatten_phi_fu_204_p4 = indvar_flatten_reg_200;
    end
end

always @ (*) begin
    if (((1'b0 == ap_block_pp0_stage0) & (ap_enable_reg_pp0_iter1 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage0) & (exitcond_flatten_reg_831 == 1'd0))) begin
        ap_phi_mux_is_first_line_1_phi_fu_236_p4 = 1'd0;
    end else begin
        ap_phi_mux_is_first_line_1_phi_fu_236_p4 = is_first_line_1_reg_232;
    end
end

always @ (*) begin
    if (((1'b0 == ap_block_pp0_stage0) & (ap_enable_reg_pp0_iter1 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage0) & (exitcond_flatten_reg_831 == 1'd0))) begin
        ap_phi_mux_p_08_rec_phi_fu_216_p4 = tmp_10_mid2_v_reg_841;
    end else begin
        ap_phi_mux_p_08_rec_phi_fu_216_p4 = p_08_rec_reg_212;
    end
end

always @ (*) begin
    if (((1'b0 == ap_block_pp0_stage0) & (ap_enable_reg_pp0_iter1 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage0) & (exitcond_flatten_reg_831 == 1'd0))) begin
        ap_phi_mux_pix_data_V_1_phi_fu_226_p4 = tmp_data_V_7_reg_992;
    end else begin
        ap_phi_mux_pix_data_V_1_phi_fu_226_p4 = pix_data_V_1_reg_223;
    end
end

always @ (*) begin
    if ((1'b1 == ap_condition_1201)) begin
        if ((ap_phi_mux_is_first_line_1_phi_fu_236_p4 == 1'd0)) begin
            ap_phi_mux_pix_data_V_3_phi_fu_259_p4 = video_in_TDATA;
        end else if ((ap_phi_mux_is_first_line_1_phi_fu_236_p4 == 1'd1)) begin
            ap_phi_mux_pix_data_V_3_phi_fu_259_p4 = ap_phi_mux_pix_data_V_1_phi_fu_226_p4;
        end else begin
            ap_phi_mux_pix_data_V_3_phi_fu_259_p4 = ap_phi_reg_pp0_iter0_pix_data_V_3_reg_256;
        end
    end else begin
        ap_phi_mux_pix_data_V_3_phi_fu_259_p4 = ap_phi_reg_pp0_iter0_pix_data_V_3_reg_256;
    end
end

always @ (*) begin
    if ((1'b1 == ap_CS_fsm_state28)) begin
        ap_ready = 1'b1;
    end else begin
        ap_ready = 1'b0;
    end
end

always @ (*) begin
    if ((ap_reg_ioackin_gmem_AWREADY == 1'b0)) begin
        ap_sig_ioackin_gmem_AWREADY = gmem_AWREADY;
    end else begin
        ap_sig_ioackin_gmem_AWREADY = 1'b1;
    end
end

always @ (*) begin
    if ((ap_reg_ioackin_gmem_WREADY == 1'b0)) begin
        ap_sig_ioackin_gmem_WREADY = gmem_WREADY;
    end else begin
        ap_sig_ioackin_gmem_WREADY = 1'b1;
    end
end

always @ (*) begin
    if (((1'b0 == ap_block_pp0_stage1_01001) & (ap_reg_ioackin_gmem_AWREADY == 1'b0) & (ap_enable_reg_pp0_iter2 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage1) & (tmp_24_reg_1027 == 1'd1))) begin
        gmem_AWVALID = 1'b1;
    end else begin
        gmem_AWVALID = 1'b0;
    end
end

always @ (*) begin
    if (((1'b0 == ap_block_pp0_stage7_11001) & (1'b1 == ap_CS_fsm_pp0_stage7) & (ap_enable_reg_pp0_iter2 == 1'b1) & (tmp_26_reg_1042 == 1'd1))) begin
        gmem_BREADY = 1'b1;
    end else begin
        gmem_BREADY = 1'b0;
    end
end

always @ (*) begin
    if (((1'b0 == ap_block_pp0_stage2_01001) & (ap_reg_ioackin_gmem_WREADY == 1'b0) & (1'b1 == ap_CS_fsm_pp0_stage2) & (ap_enable_reg_pp0_iter2 == 1'b1) & (exitcond_flatten_reg_831_pp0_iter2_reg == 1'd0))) begin
        gmem_WVALID = 1'b1;
    end else begin
        gmem_WVALID = 1'b0;
    end
end

always @ (*) begin
    if (((ap_enable_reg_pp0_iter2 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage1) & (tmp_24_reg_1027 == 1'd1) & (1'b0 == ap_block_pp0_stage1))) begin
        gmem_blk_n_AW = m_axi_gmem_AWREADY;
    end else begin
        gmem_blk_n_AW = 1'b1;
    end
end

always @ (*) begin
    if (((1'b1 == ap_CS_fsm_pp0_stage7) & (ap_enable_reg_pp0_iter2 == 1'b1) & (1'b0 == ap_block_pp0_stage7) & (tmp_26_reg_1042 == 1'd1))) begin
        gmem_blk_n_B = m_axi_gmem_BVALID;
    end else begin
        gmem_blk_n_B = 1'b1;
    end
end

always @ (*) begin
    if (((1'b1 == ap_CS_fsm_pp0_stage2) & (ap_enable_reg_pp0_iter2 == 1'b1) & (exitcond_flatten_reg_831_pp0_iter2_reg == 1'd0) & (1'b0 == ap_block_pp0_stage2))) begin
        gmem_blk_n_W = m_axi_gmem_WREADY;
    end else begin
        gmem_blk_n_W = 1'b1;
    end
end

always @ (*) begin
    if ((((1'b0 == ap_block_pp0_stage0_11001) & (1'b1 == ap_CS_fsm_pp0_stage0)) | ((1'b0 == ap_block_pp0_stage6_11001) & (1'b1 == ap_CS_fsm_pp0_stage6)) | ((1'b0 == ap_block_pp0_stage5_11001) & (1'b1 == ap_CS_fsm_pp0_stage5)) | ((1'b0 == ap_block_pp0_stage4_11001) & (1'b1 == ap_CS_fsm_pp0_stage4)) | ((1'b0 == ap_block_pp0_stage3_11001) & (1'b1 == ap_CS_fsm_pp0_stage3)) | ((1'b0 == ap_block_pp0_stage7_11001) & (1'b1 == ap_CS_fsm_pp0_stage7)) | ((1'b0 == ap_block_pp0_stage2_11001) & (1'b1 == ap_CS_fsm_pp0_stage2)) | ((1'b0 == ap_block_pp0_stage1_11001) & (1'b1 == ap_CS_fsm_pp0_stage1)))) begin
        grp_fu_391_ce = 1'b1;
    end else begin
        grp_fu_391_ce = 1'b0;
    end
end

always @ (*) begin
    if ((((1'b0 == ap_block_pp0_stage0_11001) & (1'b1 == ap_CS_fsm_pp0_stage0)) | ((1'b0 == ap_block_pp0_stage6_11001) & (1'b1 == ap_CS_fsm_pp0_stage6)) | ((1'b0 == ap_block_pp0_stage5_11001) & (1'b1 == ap_CS_fsm_pp0_stage5)) | ((1'b0 == ap_block_pp0_stage4_11001) & (1'b1 == ap_CS_fsm_pp0_stage4)) | ((1'b0 == ap_block_pp0_stage3_11001) & (1'b1 == ap_CS_fsm_pp0_stage3)) | ((1'b0 == ap_block_pp0_stage7_11001) & (1'b1 == ap_CS_fsm_pp0_stage7)) | ((1'b0 == ap_block_pp0_stage2_11001) & (1'b1 == ap_CS_fsm_pp0_stage2)) | ((1'b0 == ap_block_pp0_stage1_11001) & (1'b1 == ap_CS_fsm_pp0_stage1)))) begin
        grp_fu_428_ce = 1'b1;
    end else begin
        grp_fu_428_ce = 1'b0;
    end
end

always @ (*) begin
    if ((((1'b0 == ap_block_pp0_stage0) & (1'b1 == ap_CS_fsm_pp0_stage0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (ap_phi_mux_is_first_line_1_phi_fu_236_p4 == 1'd0) & (exitcond_flatten_fu_326_p2 == 1'd0)) | ((1'b0 == ap_block_pp0_stage6) & (1'b1 == ap_CS_fsm_pp0_stage6) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_831 == 1'd0)) | ((1'b1 == ap_CS_fsm_pp0_stage5) & (ap_enable_reg_pp0_iter0 == 1'b1) & (1'b0 == ap_block_pp0_stage5) & (exitcond_flatten_reg_831 == 1'd0)) | ((1'b1 == ap_CS_fsm_pp0_stage4) & (ap_enable_reg_pp0_iter0 == 1'b1) & (1'b0 == ap_block_pp0_stage4) & (exitcond_flatten_reg_831 == 1'd0)) | ((1'b1 == ap_CS_fsm_pp0_stage3) & (ap_enable_reg_pp0_iter0 == 1'b1) & (1'b0 == ap_block_pp0_stage3) & (exitcond_flatten_reg_831 == 1'd0)) | ((1'b1 == ap_CS_fsm_state3) & (tmp_nbreadreq_fu_146_p9 == 1'd1)) | ((ap_enable_reg_pp0_iter0 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage7) & (1'b0 == ap_block_pp0_stage7) & (exitcond_flatten_reg_831 == 1'd0)) | ((ap_enable_reg_pp0_iter0 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage2) & (exitcond_flatten_reg_831 == 1'd0) & (1'b0 == ap_block_pp0_stage2)) | ((ap_enable_reg_pp0_iter0 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage1) & (exitcond_flatten_reg_831 == 1'd0) & (1'b0 == ap_block_pp0_stage1)))) begin
        video_in_TDATA_blk_n = video_in_TVALID;
    end else begin
        video_in_TDATA_blk_n = 1'b1;
    end
end

always @ (*) begin
    if ((((1'b0 == ap_block_pp0_stage0_11001) & (ap_predicate_op79_read_state4 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage0) & (ap_enable_reg_pp0_iter0 == 1'b1)) | ((1'b0 == ap_block_pp0_stage6_11001) & (1'b1 == ap_CS_fsm_pp0_stage6) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_831 == 1'd0)) | ((1'b0 == ap_block_pp0_stage5_11001) & (1'b1 == ap_CS_fsm_pp0_stage5) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_831 == 1'd0)) | ((1'b0 == ap_block_pp0_stage4_11001) & (1'b1 == ap_CS_fsm_pp0_stage4) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_831 == 1'd0)) | ((1'b0 == ap_block_pp0_stage3_11001) & (1'b1 == ap_CS_fsm_pp0_stage3) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_831 == 1'd0)) | (~((video_in_TVALID == 1'b0) & (tmp_nbreadreq_fu_146_p9 == 1'd1)) & (1'b1 == ap_CS_fsm_state3) & (tmp_nbreadreq_fu_146_p9 == 1'd1)) | ((1'b0 == ap_block_pp0_stage7_11001) & (ap_enable_reg_pp0_iter0 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage7) & (exitcond_flatten_reg_831 == 1'd0)) | ((1'b0 == ap_block_pp0_stage2_11001) & (ap_enable_reg_pp0_iter0 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage2) & (exitcond_flatten_reg_831 == 1'd0)) | ((1'b0 == ap_block_pp0_stage1_11001) & (ap_enable_reg_pp0_iter0 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage1) & (exitcond_flatten_reg_831 == 1'd0)))) begin
        video_in_TREADY = 1'b1;
    end else begin
        video_in_TREADY = 1'b0;
    end
end

always @ (*) begin
    case (ap_CS_fsm)
        ap_ST_fsm_state1 : begin
            if (((1'b1 == ap_CS_fsm_state1) & (ap_start == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state2;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state1;
            end
        end
        ap_ST_fsm_state2 : begin
            ap_NS_fsm = ap_ST_fsm_state3;
        end
        ap_ST_fsm_state3 : begin
            if ((~((video_in_TVALID == 1'b0) & (tmp_nbreadreq_fu_146_p9 == 1'd1)) & (1'b1 == ap_CS_fsm_state3) & (tmp_user_V_fu_309_p1 == 1'd1) & (tmp_nbreadreq_fu_146_p9 == 1'd1))) begin
                ap_NS_fsm = ap_ST_fsm_pp0_stage0;
            end else if ((~((video_in_TVALID == 1'b0) & (tmp_nbreadreq_fu_146_p9 == 1'd1)) & (1'b1 == ap_CS_fsm_state3) & (tmp_user_V_fu_309_p1 == 1'd0) & (tmp_nbreadreq_fu_146_p9 == 1'd1))) begin
                ap_NS_fsm = ap_ST_fsm_state2;
            end else if ((~((video_in_TVALID == 1'b0) & (tmp_nbreadreq_fu_146_p9 == 1'd1)) & (1'b1 == ap_CS_fsm_state3) & (tmp_nbreadreq_fu_146_p9 == 1'd0))) begin
                ap_NS_fsm = ap_ST_fsm_state3;
            end else begin
                ap_NS_fsm = ap_ST_fsm_state3;
            end
        end
        ap_ST_fsm_pp0_stage0 : begin
            if ((~((1'b0 == ap_block_pp0_stage0_subdone) & (ap_enable_reg_pp0_iter1 == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_fu_326_p2 == 1'd1)) & (1'b0 == ap_block_pp0_stage0_subdone))) begin
                ap_NS_fsm = ap_ST_fsm_pp0_stage1;
            end else if (((1'b0 == ap_block_pp0_stage0_subdone) & (ap_enable_reg_pp0_iter1 == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_fu_326_p2 == 1'd1))) begin
                ap_NS_fsm = ap_ST_fsm_state28;
            end else begin
                ap_NS_fsm = ap_ST_fsm_pp0_stage0;
            end
        end
        ap_ST_fsm_pp0_stage1 : begin
            if ((1'b0 == ap_block_pp0_stage1_subdone)) begin
                ap_NS_fsm = ap_ST_fsm_pp0_stage2;
            end else begin
                ap_NS_fsm = ap_ST_fsm_pp0_stage1;
            end
        end
        ap_ST_fsm_pp0_stage2 : begin
            if ((1'b0 == ap_block_pp0_stage2_subdone)) begin
                ap_NS_fsm = ap_ST_fsm_pp0_stage3;
            end else begin
                ap_NS_fsm = ap_ST_fsm_pp0_stage2;
            end
        end
        ap_ST_fsm_pp0_stage3 : begin
            if ((1'b0 == ap_block_pp0_stage3_subdone)) begin
                ap_NS_fsm = ap_ST_fsm_pp0_stage4;
            end else begin
                ap_NS_fsm = ap_ST_fsm_pp0_stage3;
            end
        end
        ap_ST_fsm_pp0_stage4 : begin
            if ((1'b0 == ap_block_pp0_stage4_subdone)) begin
                ap_NS_fsm = ap_ST_fsm_pp0_stage5;
            end else begin
                ap_NS_fsm = ap_ST_fsm_pp0_stage4;
            end
        end
        ap_ST_fsm_pp0_stage5 : begin
            if ((1'b0 == ap_block_pp0_stage5_subdone)) begin
                ap_NS_fsm = ap_ST_fsm_pp0_stage6;
            end else begin
                ap_NS_fsm = ap_ST_fsm_pp0_stage5;
            end
        end
        ap_ST_fsm_pp0_stage6 : begin
            if ((1'b0 == ap_block_pp0_stage6_subdone)) begin
                ap_NS_fsm = ap_ST_fsm_pp0_stage7;
            end else begin
                ap_NS_fsm = ap_ST_fsm_pp0_stage6;
            end
        end
        ap_ST_fsm_pp0_stage7 : begin
            if ((~((1'b0 == ap_block_pp0_stage7_subdone) & (ap_enable_reg_pp0_iter1 == 1'b0) & (1'b1 == ap_CS_fsm_pp0_stage7) & (ap_enable_reg_pp0_iter2 == 1'b1)) & (1'b0 == ap_block_pp0_stage7_subdone))) begin
                ap_NS_fsm = ap_ST_fsm_pp0_stage0;
            end else if (((1'b0 == ap_block_pp0_stage7_subdone) & (ap_enable_reg_pp0_iter1 == 1'b0) & (1'b1 == ap_CS_fsm_pp0_stage7) & (ap_enable_reg_pp0_iter2 == 1'b1))) begin
                ap_NS_fsm = ap_ST_fsm_state28;
            end else begin
                ap_NS_fsm = ap_ST_fsm_pp0_stage7;
            end
        end
        ap_ST_fsm_state28 : begin
            ap_NS_fsm = ap_ST_fsm_state1;
        end
        default : begin
            ap_NS_fsm = 'bx;
        end
    endcase
end

assign ap_CS_fsm_pp0_stage0 = ap_CS_fsm[32'd3];

assign ap_CS_fsm_pp0_stage1 = ap_CS_fsm[32'd4];

assign ap_CS_fsm_pp0_stage2 = ap_CS_fsm[32'd5];

assign ap_CS_fsm_pp0_stage3 = ap_CS_fsm[32'd6];

assign ap_CS_fsm_pp0_stage4 = ap_CS_fsm[32'd7];

assign ap_CS_fsm_pp0_stage5 = ap_CS_fsm[32'd8];

assign ap_CS_fsm_pp0_stage6 = ap_CS_fsm[32'd9];

assign ap_CS_fsm_pp0_stage7 = ap_CS_fsm[32'd10];

assign ap_CS_fsm_state1 = ap_CS_fsm[32'd0];

assign ap_CS_fsm_state28 = ap_CS_fsm[32'd11];

assign ap_CS_fsm_state3 = ap_CS_fsm[32'd2];

assign ap_block_pp0_stage0 = ~(1'b1 == 1'b1);

always @ (*) begin
    ap_block_pp0_stage0_11001 = ((video_in_TVALID == 1'b0) & (ap_predicate_op79_read_state4 == 1'b1) & (ap_enable_reg_pp0_iter0 == 1'b1));
end

always @ (*) begin
    ap_block_pp0_stage0_subdone = ((video_in_TVALID == 1'b0) & (ap_predicate_op79_read_state4 == 1'b1) & (ap_enable_reg_pp0_iter0 == 1'b1));
end

assign ap_block_pp0_stage1 = ~(1'b1 == 1'b1);

always @ (*) begin
    ap_block_pp0_stage1_01001 = ((video_in_TVALID == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_831 == 1'd0));
end

always @ (*) begin
    ap_block_pp0_stage1_11001 = (((video_in_TVALID == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_831 == 1'd0)) | ((1'b1 == ap_block_state21_io) & (ap_enable_reg_pp0_iter2 == 1'b1)));
end

always @ (*) begin
    ap_block_pp0_stage1_subdone = (((video_in_TVALID == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_831 == 1'd0)) | ((1'b1 == ap_block_state21_io) & (ap_enable_reg_pp0_iter2 == 1'b1)));
end

assign ap_block_pp0_stage2 = ~(1'b1 == 1'b1);

always @ (*) begin
    ap_block_pp0_stage2_01001 = ((video_in_TVALID == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_831 == 1'd0));
end

always @ (*) begin
    ap_block_pp0_stage2_11001 = (((video_in_TVALID == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_831 == 1'd0)) | ((1'b1 == ap_block_state22_io) & (ap_enable_reg_pp0_iter2 == 1'b1)));
end

always @ (*) begin
    ap_block_pp0_stage2_subdone = (((video_in_TVALID == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_831 == 1'd0)) | ((1'b1 == ap_block_state22_io) & (ap_enable_reg_pp0_iter2 == 1'b1)));
end

assign ap_block_pp0_stage3 = ~(1'b1 == 1'b1);

always @ (*) begin
    ap_block_pp0_stage3_11001 = ((video_in_TVALID == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_831 == 1'd0));
end

always @ (*) begin
    ap_block_pp0_stage3_subdone = ((video_in_TVALID == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_831 == 1'd0));
end

assign ap_block_pp0_stage4 = ~(1'b1 == 1'b1);

always @ (*) begin
    ap_block_pp0_stage4_11001 = ((video_in_TVALID == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_831 == 1'd0));
end

always @ (*) begin
    ap_block_pp0_stage4_subdone = ((video_in_TVALID == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_831 == 1'd0));
end

assign ap_block_pp0_stage5 = ~(1'b1 == 1'b1);

always @ (*) begin
    ap_block_pp0_stage5_11001 = ((video_in_TVALID == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_831 == 1'd0));
end

always @ (*) begin
    ap_block_pp0_stage5_subdone = ((video_in_TVALID == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_831 == 1'd0));
end

assign ap_block_pp0_stage6 = ~(1'b1 == 1'b1);

always @ (*) begin
    ap_block_pp0_stage6_11001 = ((video_in_TVALID == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_831 == 1'd0));
end

always @ (*) begin
    ap_block_pp0_stage6_subdone = ((video_in_TVALID == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_831 == 1'd0));
end

assign ap_block_pp0_stage7 = ~(1'b1 == 1'b1);

always @ (*) begin
    ap_block_pp0_stage7_11001 = (((video_in_TVALID == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_831 == 1'd0)) | ((gmem_BVALID == 1'b0) & (ap_enable_reg_pp0_iter2 == 1'b1) & (tmp_26_reg_1042 == 1'd1)));
end

always @ (*) begin
    ap_block_pp0_stage7_subdone = (((video_in_TVALID == 1'b0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_reg_831 == 1'd0)) | ((gmem_BVALID == 1'b0) & (ap_enable_reg_pp0_iter2 == 1'b1) & (tmp_26_reg_1042 == 1'd1)));
end

always @ (*) begin
    ap_block_state10_pp0_stage6_iter0 = ((video_in_TVALID == 1'b0) & (exitcond_flatten_reg_831 == 1'd0));
end

always @ (*) begin
    ap_block_state11_pp0_stage7_iter0 = ((video_in_TVALID == 1'b0) & (exitcond_flatten_reg_831 == 1'd0));
end

assign ap_block_state12_pp0_stage0_iter1 = ~(1'b1 == 1'b1);

assign ap_block_state13_pp0_stage1_iter1 = ~(1'b1 == 1'b1);

assign ap_block_state14_pp0_stage2_iter1 = ~(1'b1 == 1'b1);

assign ap_block_state15_pp0_stage3_iter1 = ~(1'b1 == 1'b1);

assign ap_block_state16_pp0_stage4_iter1 = ~(1'b1 == 1'b1);

assign ap_block_state17_pp0_stage5_iter1 = ~(1'b1 == 1'b1);

assign ap_block_state18_pp0_stage6_iter1 = ~(1'b1 == 1'b1);

assign ap_block_state19_pp0_stage7_iter1 = ~(1'b1 == 1'b1);

assign ap_block_state20_pp0_stage0_iter2 = ~(1'b1 == 1'b1);

always @ (*) begin
    ap_block_state21_io = ((ap_sig_ioackin_gmem_AWREADY == 1'b0) & (tmp_24_reg_1027 == 1'd1));
end

assign ap_block_state21_pp0_stage1_iter2 = ~(1'b1 == 1'b1);

always @ (*) begin
    ap_block_state22_io = ((ap_sig_ioackin_gmem_WREADY == 1'b0) & (exitcond_flatten_reg_831_pp0_iter2_reg == 1'd0));
end

assign ap_block_state22_pp0_stage2_iter2 = ~(1'b1 == 1'b1);

assign ap_block_state23_pp0_stage3_iter2 = ~(1'b1 == 1'b1);

assign ap_block_state24_pp0_stage4_iter2 = ~(1'b1 == 1'b1);

assign ap_block_state25_pp0_stage5_iter2 = ~(1'b1 == 1'b1);

assign ap_block_state26_pp0_stage6_iter2 = ~(1'b1 == 1'b1);

always @ (*) begin
    ap_block_state27_pp0_stage7_iter2 = ((gmem_BVALID == 1'b0) & (tmp_26_reg_1042 == 1'd1));
end

always @ (*) begin
    ap_block_state3 = ((video_in_TVALID == 1'b0) & (tmp_nbreadreq_fu_146_p9 == 1'd1));
end

always @ (*) begin
    ap_block_state4_pp0_stage0_iter0 = ((video_in_TVALID == 1'b0) & (ap_predicate_op79_read_state4 == 1'b1));
end

always @ (*) begin
    ap_block_state5_pp0_stage1_iter0 = ((video_in_TVALID == 1'b0) & (exitcond_flatten_reg_831 == 1'd0));
end

always @ (*) begin
    ap_block_state6_pp0_stage2_iter0 = ((video_in_TVALID == 1'b0) & (exitcond_flatten_reg_831 == 1'd0));
end

always @ (*) begin
    ap_block_state7_pp0_stage3_iter0 = ((video_in_TVALID == 1'b0) & (exitcond_flatten_reg_831 == 1'd0));
end

always @ (*) begin
    ap_block_state8_pp0_stage4_iter0 = ((video_in_TVALID == 1'b0) & (exitcond_flatten_reg_831 == 1'd0));
end

always @ (*) begin
    ap_block_state9_pp0_stage5_iter0 = ((video_in_TVALID == 1'b0) & (exitcond_flatten_reg_831 == 1'd0));
end

always @ (*) begin
    ap_condition_1201 = ((1'b0 == ap_block_pp0_stage0) & (1'b1 == ap_CS_fsm_pp0_stage0) & (ap_enable_reg_pp0_iter0 == 1'b1) & (exitcond_flatten_fu_326_p2 == 1'd0));
end

always @ (*) begin
    ap_condition_1204 = ((ap_enable_reg_pp0_iter2 == 1'b1) & (1'b1 == ap_CS_fsm_pp0_stage1) & (tmp_24_reg_1027 == 1'd1));
end

always @ (*) begin
    ap_condition_1208 = ((1'b1 == ap_CS_fsm_pp0_stage2) & (ap_enable_reg_pp0_iter2 == 1'b1) & (exitcond_flatten_reg_831_pp0_iter2_reg == 1'd0));
end

assign ap_enable_pp0 = (ap_idle_pp0 ^ 1'b1);

assign ap_phi_reg_pp0_iter0_pix_data_V_3_reg_256 = 'bx;

always @ (*) begin
    ap_predicate_op79_read_state4 = ((ap_phi_mux_is_first_line_1_phi_fu_236_p4 == 1'd0) & (exitcond_flatten_fu_326_p2 == 1'd0));
end

always @ (*) begin
    ap_rst_n_inv = ~ap_rst_n;
end

assign blk_7_fu_655_p9 = {{{{{{{{y1_7_reg_1022}, {y1_6_reg_1007_pp0_iter2_reg}}, {y1_5_reg_982_pp0_iter1_reg}}, {y1_4_reg_962_pp0_iter1_reg}}, {y1_3_reg_942_pp0_iter1_reg}}, {y1_2_reg_922_pp0_iter1_reg}}, {y1_1_reg_902_pp0_iter1_reg}}, {y1_reg_882_pp0_iter1_reg}};

assign blk_idx_1_fu_403_p3 = ((tmp_5_fu_338_p2[0:0] === 1'b1) ? 6'd1 : blk_idx_op_fu_397_p2);

assign blk_idx_op_fu_397_p2 = (ap_phi_mux_blk_idx_phi_fu_249_p4 + 6'd1);

assign exitcond_flatten_fu_326_p2 = ((ap_phi_mux_indvar_flatten_phi_fu_204_p4 == 13'd7200) ? 1'b1 : 1'b0);

assign fb_out2_sum3_cast_fu_667_p1 = fb_out2_sum3_reg_1017_pp0_iter2_reg;

assign fb_out2_sum3_fu_632_p2 = (tmp_10_mid2_cast_fu_613_p1 + tmp_1_cast_reg_808);

assign gmem_AWADDR = fb_out2_sum3_cast_fu_667_p1;

assign grp_fu_271_p4 = {{video_in_TDATA[15:8]}};

assign grp_fu_391_p1 = 13'd40;

assign grp_fu_428_p1 = 13'd40;

assign grp_fu_683_p0 = 16'd77;

assign grp_fu_683_p1 = grp_fu_683_p10;

assign grp_fu_683_p10 = tmp_3_reg_852;

assign grp_fu_690_p0 = 14'd29;

assign grp_fu_690_p1 = grp_fu_690_p10;

assign grp_fu_690_p10 = tmp_15_reg_847;

assign grp_fu_698_p0 = 16'd77;

assign grp_fu_698_p1 = grp_fu_698_p10;

assign grp_fu_698_p10 = reg_291;

assign grp_fu_705_p0 = 14'd29;

assign grp_fu_705_p1 = grp_fu_705_p10;

assign grp_fu_705_p10 = tmp_16_reg_872;

assign grp_fu_713_p0 = 16'd77;

assign grp_fu_713_p1 = grp_fu_713_p10;

assign grp_fu_713_p10 = reg_291;

assign grp_fu_720_p0 = 14'd29;

assign grp_fu_720_p1 = grp_fu_720_p10;

assign grp_fu_720_p10 = tmp_17_reg_892;

assign grp_fu_728_p0 = 16'd77;

assign grp_fu_728_p1 = grp_fu_728_p10;

assign grp_fu_728_p10 = reg_291;

assign grp_fu_735_p0 = 14'd29;

assign grp_fu_735_p1 = grp_fu_735_p10;

assign grp_fu_735_p10 = tmp_18_reg_912;

assign grp_fu_743_p0 = 16'd77;

assign grp_fu_743_p1 = grp_fu_743_p10;

assign grp_fu_743_p10 = reg_291;

assign grp_fu_750_p0 = 14'd29;

assign grp_fu_750_p1 = grp_fu_750_p10;

assign grp_fu_750_p10 = tmp_19_reg_932;

assign grp_fu_758_p0 = 16'd77;

assign grp_fu_758_p1 = grp_fu_758_p10;

assign grp_fu_758_p10 = reg_291;

assign grp_fu_765_p0 = 14'd29;

assign grp_fu_765_p1 = grp_fu_765_p10;

assign grp_fu_765_p10 = tmp_20_reg_952;

assign grp_fu_773_p0 = 16'd77;

assign grp_fu_773_p1 = grp_fu_773_p10;

assign grp_fu_773_p10 = reg_291;

assign grp_fu_780_p0 = 14'd29;

assign grp_fu_780_p1 = grp_fu_780_p10;

assign grp_fu_780_p10 = tmp_21_reg_972;

assign grp_fu_788_p0 = 16'd77;

assign grp_fu_788_p1 = grp_fu_788_p10;

assign grp_fu_788_p10 = reg_291;

assign grp_fu_795_p0 = 14'd29;

assign grp_fu_795_p1 = grp_fu_795_p10;

assign grp_fu_795_p10 = tmp_22_reg_997;

assign indvar_flatten_next_fu_332_p2 = (ap_phi_mux_indvar_flatten_phi_fu_204_p4 + 13'd1);

assign p_rec_dup4_fu_344_p2 = (ap_phi_mux_p_08_rec_phi_fu_216_p4 + tmp_3_cast_reg_826);

assign tmp_10_mid2_cast_fu_613_p1 = tmp_10_mid2_v_reg_841;

assign tmp_10_mid2_v_fu_349_p3 = ((tmp_5_fu_338_p2[0:0] === 1'b1) ? p_rec_dup4_fu_344_p2 : ap_phi_mux_p_08_rec_phi_fu_216_p4);

assign tmp_15_fu_357_p1 = ap_phi_mux_pix_data_V_3_phi_fu_259_p4[7:0];

assign tmp_16_fu_414_p1 = video_in_TDATA[7:0];

assign tmp_17_fu_449_p1 = video_in_TDATA[7:0];

assign tmp_18_fu_479_p1 = video_in_TDATA[7:0];

assign tmp_19_fu_509_p1 = video_in_TDATA[7:0];

assign tmp_1_cast_fu_305_p1 = tmp_1_fu_295_p4;

assign tmp_1_fu_295_p4 = {{fb_out[31:3]}};

assign tmp_20_fu_539_p1 = video_in_TDATA[7:0];

assign tmp_21_fu_569_p1 = video_in_TDATA[7:0];

assign tmp_22_fu_599_p1 = video_in_TDATA[7:0];

assign tmp_24_fu_649_p2 = ((grp_fu_391_p2 == 13'd0) ? 1'b1 : 1'b0);

assign tmp_26_fu_677_p2 = ((grp_fu_428_p2 == 13'd0) ? 1'b1 : 1'b0);

assign tmp_2_fu_313_p4 = {{stride_read_reg_803[31:3]}};

assign tmp_3_cast_fu_322_p1 = tmp_2_fu_313_p4;

assign tmp_5_fu_338_p2 = ((ap_phi_mux_blk_idx_phi_fu_249_p4 == 6'd40) ? 1'b1 : 1'b0);

assign tmp_6_1_fu_422_p1 = tmp_6_1_fu_422_p10;

assign tmp_6_1_fu_422_p10 = grp_fu_271_p4;

assign tmp_6_1_fu_422_p2 = (16'd150 * tmp_6_1_fu_422_p1);

assign tmp_6_2_fu_457_p1 = tmp_6_2_fu_457_p10;

assign tmp_6_2_fu_457_p10 = grp_fu_271_p4;

assign tmp_6_2_fu_457_p2 = (16'd150 * tmp_6_2_fu_457_p1);

assign tmp_6_3_fu_487_p1 = tmp_6_3_fu_487_p10;

assign tmp_6_3_fu_487_p10 = grp_fu_271_p4;

assign tmp_6_3_fu_487_p2 = (16'd150 * tmp_6_3_fu_487_p1);

assign tmp_6_4_fu_517_p1 = tmp_6_4_fu_517_p10;

assign tmp_6_4_fu_517_p10 = grp_fu_271_p4;

assign tmp_6_4_fu_517_p2 = (16'd150 * tmp_6_4_fu_517_p1);

assign tmp_6_5_fu_547_p1 = tmp_6_5_fu_547_p10;

assign tmp_6_5_fu_547_p10 = grp_fu_271_p4;

assign tmp_6_5_fu_547_p2 = (16'd150 * tmp_6_5_fu_547_p1);

assign tmp_6_6_fu_577_p1 = tmp_6_6_fu_577_p10;

assign tmp_6_6_fu_577_p10 = grp_fu_271_p4;

assign tmp_6_6_fu_577_p2 = (16'd150 * tmp_6_6_fu_577_p1);

assign tmp_6_7_fu_607_p1 = tmp_6_7_fu_607_p10;

assign tmp_6_7_fu_607_p10 = grp_fu_271_p4;

assign tmp_6_7_fu_607_p2 = (16'd150 * tmp_6_7_fu_607_p1);

assign tmp_cast_fu_361_p4 = {{ap_phi_mux_pix_data_V_3_phi_fu_259_p4[15:8]}};

assign tmp_nbreadreq_fu_146_p9 = video_in_TVALID;

assign tmp_s_fu_385_p1 = tmp_s_fu_385_p10;

assign tmp_s_fu_385_p10 = tmp_cast_fu_361_p4;

assign tmp_s_fu_385_p2 = (16'd150 * tmp_s_fu_385_p1);

assign tmp_user_V_fu_309_p1 = video_in_TUSER;

always @ (posedge ap_clk) begin
    tmp_1_cast_reg_808[37:29] <= 9'b000000000;
    tmp_3_cast_reg_826[36:29] <= 8'b00000000;
end

endmodule //RGB2yfb
